require "import"
import "java.text.SimpleDateFormat"
import "java.util.Date"
import "android.content.Intent"
import "android.content.IntentFilter"
import "android.os.BatteryManager"
import "android.speech.tts.TextToSpeech"
import "android.speech.tts.TextToSpeech$OnInitListener"
import "java.util.Locale"

local tts = nil
local context = activity or service -- NULL प्रॉब्लम से बचने के लिए

function initTTS()
    if not context then
        print("Error: Context is null!")
        return
    end

    tts = luajava.new(TextToSpeech, context, luajava.createProxy("android.speech.tts.TextToSpeech$OnInitListener", {
        onInit = function(status)
            if status == TextToSpeech.SUCCESS then
                tts.setLanguage(Locale("hi", "IN")) -- हिंदी में सेट किया
                print("TTS Initialized Successfully")
                speakDateTime() -- इनिशियलाइज़ होते ही बोलना शुरू कर दे
            else
                print("TTS Initialization Failed")
            end
        end
    }))
end

function speakMessage(message)
    if tts then
        tts.speak(message, TextToSpeech.QUEUE_FLUSH, nil, "TTS_ID")
    else
        print("TTS is not initialized.")
    end
end

function speakDateTime()
    if not context then
        print("Error: Context is null!")
        return
    end

    local currentDate = os.date("%A, %B %d, %Y")
    local formattedTime = SimpleDateFormat("hh:mm a").format(Date())

    local batteryIntent = context.registerReceiver(nil, IntentFilter(Intent.ACTION_BATTERY_CHANGED))
    local batteryPercent = "Unknown"

    if batteryIntent then
        local level = batteryIntent.getIntExtra(BatteryManager.EXTRA_LEVEL, -1)
        local scale = batteryIntent.getIntExtra(BatteryManager.EXTRA_SCALE, -1)
        if level >= 0 and scale > 0 then
            batteryPercent = math.floor((level / scale) * 100)
        end
    end

    local message = "आज की तारीख " .. currentDate .. " है। समय " .. formattedTime .. " है। बैटरी " .. batteryPercent .. " प्रतिशत है।"
    speakMessage(message)
end

initTTS()